/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/
#ifndef _BORDERS_H_
#define _BORDERS_H_

#pragma once

#include "ExcelClone.h"
#include "DispatchHook.h"
#include "OOTableBorder.h"

/*
CBorders class provides functionality of the MS Excel Application object by using Open Office.
It implements Borders interface of the MS Excel.
*/

namespace AutomateIT
{
    namespace ExcelClone
    {
        class CRange;

        class ATL_NO_VTABLE CBorders : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public CDispatchHook< IDispatchImpl<Borders, &IID_Borders, &LIBID_ExcelCloneLib, 1, 0> >
        {
        public:
            CBorders();
            virtual ~CBorders();

            BEGIN_COM_MAP(CBorders)
                COM_INTERFACE_ENTRY(Borders)
                COM_INTERFACE_ENTRY(IDispatch)
            END_COM_MAP()

            DECLARE_PROTECT_FINAL_CONSTRUCT()

        public:

            HRESULT __stdcall get_Application(_Application	**RHS);
            HRESULT __stdcall get_Creator(XlCreator *RHS);
            HRESULT __stdcall get_Parent(IDispatch **RHS);
            HRESULT __stdcall get_Color(VARIANT *RHS);
            HRESULT __stdcall put_Color(VARIANT RHS);
            HRESULT __stdcall get_ColorIndex(VARIANT *RHS);
            HRESULT __stdcall put_ColorIndex(VARIANT RHS);
            HRESULT __stdcall get_Count(long *RHS);
            HRESULT __stdcall get_Item(XlBordersIndex Index, Border **RHS);
            HRESULT __stdcall get_LineStyle(VARIANT *RHS);
            HRESULT __stdcall put_LineStyle(VARIANT RHS);
            HRESULT __stdcall get__NewEnum(IUnknown **RHS);
            HRESULT __stdcall get_Value(VARIANT *RHS);
            HRESULT __stdcall put_Value(VARIANT RHS);
            HRESULT __stdcall get_Weight(VARIANT *RHS);
            HRESULT __stdcall put_Weight(VARIANT RHS);
            HRESULT __stdcall get__Default(XlBordersIndex Index, Border **RHS);

        public:

            HRESULT Initialize( CRange* pParentRange, OpenOfficeWrapper::COORange* pRange);

        private:

            OpenOfficeWrapper::COOTableBorderPtr m_pTableBorder;
            OpenOfficeWrapper::COORange* m_pOOParentRange;
            CRange* m_pParentRange;

        private:

            static const XlBordersIndex CBorders::m_indices[];
            static const int CBorders::m_indicesSize;

        };

        typedef CComObject<CBorders> CBordersObject;
        typedef CComPtr<CBorders> CBordersPtr;

    }
}

#endif // _BORDERS_H_
