/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "StdAfx.h"
#include "OONumberFormats.h"

using namespace AutomateIT::Utils;
using namespace AutomateIT::OpenOfficeWrapper;

COONumberFormats::COONumberFormats()
{
}

COONumberFormats::~COONumberFormats()
{
}

HRESULT COONumberFormats::Initialize( IDispatchPtr dispatch )
{
    m_pdNumberFormats = dispatch;
    return S_OK;
}

HRESULT COONumberFormats::QueryKey( BSTR bstrFormat, COOCharLocale* pLocale, bool bVal, int* piKey )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdNumberFormats, L"queryKey", 3, CComVariant(bstrFormat), CComVariant(pLocale->m_pdCharLocale), CComVariant(bVal));
    CHECKERROR;
    hr = result.ChangeType(VT_I4);
    CHECKERROR;
    (*piKey) = result.intVal;
    return hr;
}

HRESULT COONumberFormats::AddNew( BSTR bstrFormat, COOCharLocale* pLocale, int* piKey )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdNumberFormats, L"addNew", 2, CComVariant(bstrFormat), CComVariant(pLocale->m_pdCharLocale));
    CHECKERROR;
    hr = result.ChangeType(VT_I4);
    CHECKERROR;
    (*piKey) = result.intVal;
    return hr;
}

HRESULT COONumberFormats::GetByKey( int iKey, BSTR* pbstrFormat )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdNumberFormats, L"getByKey", 1, CComVariant(iKey));
    CHECKERROR;

    IDispatchPtr pdPropertySet = result.pdispVal;

    result.Clear();
    hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, pdPropertySet, L"FormatString", 0);
    CHECKERROR;

    (*pbstrFormat) = result.bstrVal;
    
    return hr;
}