
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _OO_PAGE_SETUP_STYLE_H_
#define _OO_PAGE_SETUP_STYLE_H_

#pragma once

#include "IDispatchWrapper.h"

namespace AutomateIT
{
    namespace OpenOfficeWrapper
    {
        class ATL_NO_VTABLE COOPageSetupStyle : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public IUnknown
        {
        public:

            BEGIN_COM_MAP(COOPageSetupStyle)
                COM_INTERFACE_ENTRY(IUnknown)
            END_COM_MAP( )

            COOPageSetupStyle();
            virtual ~COOPageSetupStyle();

            HRESULT Initialize(IDispatchPtr dispatch);

            HRESULT get_LeftMargin(int* piLeftMargin);
            HRESULT put_LeftMargin(int iLeftMargin);

            HRESULT get_RightMargin(int* piRightMargin);
            HRESULT put_RightMargin(int iRightMargin);

            HRESULT get_TopMargin(int* piTopMargin);
            HRESULT put_TopMargin(int iTopMargin);

            HRESULT get_BottomMargin(int* piBottomMargin);
            HRESULT put_BottomMargin(int iBottomMargin);

            HRESULT get_IsLandscape(bool* pbIsLandscape);
            HRESULT put_IsLandscape(bool bIsLandscape);

            HRESULT get_PageScale(short* psPageScale);
            HRESULT put_PageScale(short sPageScale);
            
            HRESULT get_ScaleToPagesY(short* psScaleToPagesY);
            HRESULT put_ScaleToPagesY(short sScaleToPagesY);

            HRESULT get_ScaleToPagesX(short* psScaleToPagesX);
            HRESULT put_ScaleToPagesX(short sScaleToPagesX);

            HRESULT get_HeaderHeight(long* plHeaderHeight);
            HRESULT put_HeaderHeight(long lHeaderHeight);

            HRESULT get_FooterHeight(long* plFooterHeight);
            HRESULT put_FooterHeight(long lFooterHeight);

            HRESULT get_CenterHorizontally(bool* pbCenterHorizontally);
            HRESULT put_CenterHorizontally(bool bCenterHorizontally);

            HRESULT get_CenterVertically(bool* pbCenterVertically);
            HRESULT put_CenterVertically(bool bCenterVertically);

        private:

            IDispatchPtr m_pdPageSetupStyle;

        };

        typedef CComPtr<COOPageSetupStyle> COOPageSetupStylePtr;
        typedef CComObject<COOPageSetupStyle> COOPageSetupStyleObject;

    }
}

#endif // _OO_PAGE_SETUP_STYLE_H_
