/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "StdAfx.h"
#include "OOSheets.h"

using namespace AutomateIT::Utils;
using namespace AutomateIT::OpenOfficeWrapper;

COOSheets::COOSheets()
{
}

COOSheets::~COOSheets()
{
}

HRESULT COOSheets::Initialize( IDispatchPtr dispatch )
{
    m_pdSheets = dispatch;
    return S_OK;
}

HRESULT COOSheets::GetByIndex( long index, COORange** ppSheet )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdSheets, L"getByIndex", 1, CComVariant(index));
    CHECKERROR;
    IDispatchPtr dispatch = result.pdispVal;

    COORangeObject* pSheet(NULL); 
    hr = COORangeObject::CreateInstance(&pSheet);
    CHECKERROR;

    COORangePtr pSheetPtr(pSheet); 
    hr = pSheetPtr->Initialize(dispatch);
    CHECKERROR;

    (*ppSheet) = pSheetPtr;
    (*ppSheet)->AddRef();

    return hr;

}

HRESULT AutomateIT::OpenOfficeWrapper::COOSheets::GetByName( BSTR name, COORange** ppSheet )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdSheets, L"getByName", 1, CComVariant(name));
    CHECKERROR;
    IDispatchPtr dispatch = result.pdispVal;

    COORangeObject* pSheet(NULL); 
    hr = COORangeObject::CreateInstance(&pSheet);
    CHECKERROR;

    COORangePtr pSheetPtr(pSheet); 
    hr = pSheetPtr->Initialize(dispatch);
    CHECKERROR;

    (*ppSheet) = pSheetPtr;
    (*ppSheet)->AddRef();

    return hr;
}

HRESULT COOSheets::InsertNewByName( BSTR name, long index )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdSheets, L"insertNewByName", 2, CComVariant(name), CComVariant(index));
    CHECKERROR;
    return hr;
}

HRESULT COOSheets::Count( long* count )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdSheets, L"Count", 0);
    CHECKERROR;
    (*count) = result.lVal;
    return hr;
}

HRESULT COOSheets::RemoveByName(BSTR name)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdSheets, L"removeByName", 1, CComVariant(name));
    CHECKERROR;
    return hr;
}
