/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/


#include "stdafx.h"
#include "OOStyleFamilies.h"

using namespace AutomateIT;
using namespace AutomateIT::Utils;
using namespace AutomateIT::OpenOfficeWrapper;

COOStyleFamilies::COOStyleFamilies()
{
}

COOStyleFamilies::~COOStyleFamilies()
{
}

HRESULT COOStyleFamilies::Initialize(IDispatchPtr dispatch)
{
    m_pdStyleFamilies = dispatch;
    return S_OK;
}


HRESULT COOStyleFamilies::GetPageStyles(COOPageStyles** ppPageStyles)
{
    CComVariant styles = GetByName(CComVariant(L"PageStyles"));
    IDispatchPtr pdPageStyles = styles.pdispVal;
    COOPageStylesObject* pPageStylesObject(NULL);
    HRESULT hr = COOPageStylesObject::CreateInstance(&pPageStylesObject);
    CHECKERROR;
    COOPageStylesPtr pPageStyles(pPageStylesObject);
    hr = pPageStyles->Initialize(pdPageStyles);
    CHECKERROR;

    (*ppPageStyles) = pPageStyles;
    (*ppPageStyles)->AddRef();

    return hr;
}

CComVariant COOStyleFamilies::GetByName(const CComVariant& name)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdStyleFamilies, L"getByName", 1, name);
    return result;
}