
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _OO_TABLE_BORDER_H_
#define _OO_TABLE_BORDER_H_

#pragma once

#include "IDispatchWrapper.h"

namespace AutomateIT
{
    namespace OpenOfficeWrapper
    {
        class COOBorderLine;

        class ATL_NO_VTABLE COOTableBorder : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public IUnknown
        {
        public:

            friend class COORange;

            BEGIN_COM_MAP(COOTableBorder)
                COM_INTERFACE_ENTRY(IUnknown)
            END_COM_MAP( )

            COOTableBorder();
            virtual ~COOTableBorder();

            HRESULT Initialize(IDispatchPtr dispatch);

            HRESULT get_TopLine(COOBorderLine** ppBorderLine);
            HRESULT put_TopLine(COOBorderLine* pBorderLine);
        
            HRESULT get_LeftLine(COOBorderLine** ppBorderLine);
            HRESULT put_LeftLine(COOBorderLine* pBorderLine);

            HRESULT get_RightLine(COOBorderLine** ppBorderLine);
            HRESULT put_RightLine(COOBorderLine* pBorderLine);

            HRESULT get_BottomLine(COOBorderLine** ppBorderLine);
            HRESULT put_BottomLine(COOBorderLine* pBorderLine);

            HRESULT get_HorizontalLine(COOBorderLine** ppBorderLine);
            HRESULT put_HorizontalLine(COOBorderLine* pBorderLine);

            HRESULT get_VerticalLine(COOBorderLine** ppBorderLine);
            HRESULT put_VerticalLine(COOBorderLine* pBorderLine);

        private:

            IDispatchPtr m_pdTableBorder;

        };

        typedef CComPtr<COOTableBorder> COOTableBorderPtr;
        typedef CComObject<COOTableBorder> COOTableBorderObject;

    }
}

#endif // _OO_TABLE_BORDER_H_
