
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/


#pragma once

#include "resource.h"
#include "WordClone.h"
#include "WordBasic.h"



/*
	CApplication class implements methods of Application Word object.
	The main purpose of this clas is to retreive WordBasic object.
*/
namespace AutomateIT
{
	namespace WordClone
	{
		class ATL_NO_VTABLE CApplication : 
			public CComObjectRootEx<CComSingleThreadModel>,
			public CComCoClass<CApplication, &CLSID_Application>,
			public IDispatchImpl<IApplication, &IID_IApplication, &LIBID_WordCloneLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
		{
		public:
			CApplication();
			~CApplication();

			DECLARE_CLASSFACTORY_SINGLETON(CApplication)

			DECLARE_REGISTRY_RESOURCEID(IDR_WORDAPPLICATION)

			DECLARE_NOT_AGGREGATABLE(CApplication)

			BEGIN_COM_MAP(CApplication)
				COM_INTERFACE_ENTRY(IApplication)
				COM_INTERFACE_ENTRY(IDispatch)
			END_COM_MAP()

			DECLARE_PROTECT_FINAL_CONSTRUCT()

			HRESULT FinalConstruct()
			{
				return S_OK;
			}

			void FinalRelease() 
			{
			}

		public: 
			// IApplication interface methods
			STDMETHOD(get_Application)(IApplication** app);
			STDMETHOD(get_Creator)(long* creator);
			STDMETHOD(get_Parent)(LPDISPATCH* parent);
			STDMETHOD(get_Name)(BSTR* name);
			STDMETHOD(get_Documents)(Documents** docs);
			STDMETHOD(get_Windows)(IDispatch** prop);
			STDMETHOD(get_ActiveDocument)(IDispatch** prop);
			STDMETHOD(get_ActiveWindow)(IDispatch** prop);
			STDMETHOD(get_Selection)(Selection** selection);
			STDMETHOD(get_WordBasic)(IDispatch** wordBasic);
			STDMETHOD(get_RecentFiles)(IDispatch** prop);
			STDMETHOD(get_NormalTemplate)(IDispatch** prop);
			STDMETHOD(get_System)(IDispatch** prop);
			STDMETHOD(get_AutoCorrect)(IDispatch** prop);
			STDMETHOD(get_FontNames)(IDispatch** prop);
			STDMETHOD(get_LandscapeFontNames)(IDispatch** prop);
			STDMETHOD(get_PortraitFontNames)(IDispatch** prop);
			STDMETHOD(get_Languages)(IDispatch** prop);
			STDMETHOD(get_Assistant)(IDispatch** prop);
			STDMETHOD(get_Browser)(IDispatch** prop);
			STDMETHOD(get_FileConverters)(IDispatch** prop);
			STDMETHOD(get_MailingLabel)(IDispatch** prop);
			STDMETHOD(get_Dialogs)(IDispatch** prop);
			STDMETHOD(get_CaptionLabels)(IDispatch** prop);
			STDMETHOD(get_AutoCaptions)(IDispatch** prop);
			STDMETHOD(get_AddIns)(IDispatch** prop);
			STDMETHOD(get_Visible)(VARIANT_BOOL* prop);
			STDMETHOD(put_Visible)(VARIANT_BOOL prop);
			STDMETHOD(get_Version)(BSTR* pVersion);
			STDMETHOD(get_ScreenUpdating)(VARIANT_BOOL* prop);
			STDMETHOD(put_ScreenUpdating)(VARIANT_BOOL prop);
			STDMETHOD(get_PrintPreview)(VARIANT_BOOL* prop);
			STDMETHOD(put_PrintPreview)(VARIANT_BOOL prop);
			STDMETHOD(get_Tasks)(IDispatch** prop);
			STDMETHOD(get_DisplayStatusBar)(VARIANT_BOOL* prop);
			STDMETHOD(put_DisplayStatusBar)(VARIANT_BOOL prop);
			STDMETHOD(get_SpecialMode)(VARIANT_BOOL* prop);
			STDMETHOD(get_UsableWidth)(long* prop);
			STDMETHOD(get_UsableHeight)(long* prop);
			STDMETHOD(get_MathCoprocessorAvailable)(VARIANT_BOOL* prop);
			STDMETHOD(get_MouseAvailable)(VARIANT_BOOL* prop);
			STDMETHOD(get_International)(WdInternationalIndex Index, VARIANT* prop);
			STDMETHOD(get_Build)(BSTR* prop);
			STDMETHOD(get_CapsLock)(VARIANT_BOOL* prop);
			STDMETHOD(get_NumLock)(VARIANT_BOOL* prop);
			STDMETHOD(get_UserName)(BSTR* prop);
			STDMETHOD(put_UserName)(BSTR prop);
			STDMETHOD(get_UserInitials)(BSTR* prop);
			STDMETHOD(put_UserInitials)(BSTR prop);
			STDMETHOD(get_UserAddress)(BSTR* prop);
			STDMETHOD(put_UserAddress)(BSTR prop);
			STDMETHOD(get_MacroContainer)(LPDISPATCH* prop);
			STDMETHOD(get_DisplayRecentFiles)(VARIANT_BOOL* prop);
			STDMETHOD(put_DisplayRecentFiles)(VARIANT_BOOL prop);
			STDMETHOD(get_CommandBars)(IDispatch** prop);
			STDMETHOD(get_SynonymInfo)(BSTR Word, VARIANT* LanguageID, IDispatch** prop);
			STDMETHOD(get_VBE)(IDispatch** prop);
			STDMETHOD(get_DefaultSaveFormat)(BSTR* prop);
			STDMETHOD(put_DefaultSaveFormat)(BSTR prop);
			STDMETHOD(get_ListGalleries)(IDispatch** prop);
			STDMETHOD(get_ActivePrinter)(BSTR* prop);
			STDMETHOD(put_ActivePrinter)(BSTR prop);
			STDMETHOD(get_Templates)(IDispatch** prop);
			STDMETHOD(get_CustomizationContext)(LPDISPATCH* prop);
			STDMETHOD(put_CustomizationContext)(LPDISPATCH prop);
			STDMETHOD(get_KeyBindings)(IDispatch** prop);
			STDMETHOD(get_KeysBoundTo)(WdKeyCategory KeyCategory, BSTR Command, VARIANT* CommandParameter, IDispatch** prop);
			STDMETHOD(get_FindKey)(long KeyCode, VARIANT* KeyCode2, IDispatch** prop);
			STDMETHOD(get_Caption)(BSTR* prop);
			STDMETHOD(put_Caption)(BSTR prop);
			STDMETHOD(get_Path)(BSTR* prop);
			STDMETHOD(get_DisplayScrollBars)(VARIANT_BOOL* prop);
			STDMETHOD(put_DisplayScrollBars)(VARIANT_BOOL prop);
			STDMETHOD(get_StartupPath)(BSTR* prop);
			STDMETHOD(put_StartupPath)(BSTR prop);
			STDMETHOD(get_BackgroundSavingStatus)(long* prop);
			STDMETHOD(get_BackgroundPrintingStatus)(long* prop);
			STDMETHOD(get_Left)(long* prop);
			STDMETHOD(put_Left)(long prop);
			STDMETHOD(get_Top)(long* prop);
			STDMETHOD(put_Top)(long prop);
			STDMETHOD(put_Width)(long prop);
			STDMETHOD(get_Height)(long* prop);
			STDMETHOD(put_Height)(long prop);
			STDMETHOD(get_WindowState)(WdWindowState* prop);
			STDMETHOD(put_WindowState)(WdWindowState prop);
			STDMETHOD(get_DisplayAutoCompleteTips)(VARIANT_BOOL* prop);
			STDMETHOD(put_DisplayAutoCompleteTips)(VARIANT_BOOL prop);
			STDMETHOD(get_Options)(Options** options);
			STDMETHOD(get_DisplayAlerts)(WdAlertLevel* prop);
			STDMETHOD(put_DisplayAlerts)(WdAlertLevel prop);
			STDMETHOD(get_CustomDictionaries)(IDispatch** prop);
			STDMETHOD(get_PathSeparator)(BSTR* prop);
			STDMETHOD(put_StatusBar)(BSTR);
			STDMETHOD(put_DisplayScreenTips)(VARIANT_BOOL prop);
			STDMETHOD(get_EnableCancelKey)(WdEnableCancelKey* prop);
			STDMETHOD(put_EnableCancelKey)(WdEnableCancelKey prop);
			STDMETHOD(get_MailSystem)(WdMailSystem* prop);
			STDMETHOD(get_DefaultTableSeparator)(BSTR* prop);
			STDMETHOD(put_DefaultTableSeparator)(BSTR prop);
			STDMETHOD(get_ShowVisualBasicEditor)(VARIANT_BOOL* prop);
			STDMETHOD(put_ShowVisualBasicEditor)(VARIANT_BOOL prop);
			STDMETHOD(get_BrowseExtraFileTypes)(BSTR* prop);
			STDMETHOD(put_BrowseExtraFileTypes)(BSTR prop);
			STDMETHOD(get_IsObjectValid)(LPDISPATCH Object, VARIANT_BOOL* prop);
			STDMETHOD(get_HangulHanjaDictionaries)(IDispatch** prop);
			STDMETHOD(get_MailMessage)(IDispatch** prop);
			STDMETHOD(get_FocusInMailHeader)(VARIANT_BOOL* prop);
			STDMETHOD(Quit)(VARIANT* SaveChanges, VARIANT* OriginalFormat, VARIANT* RouteDocument);
			STDMETHOD(ScreenRefresh)();
			STDMETHOD(PrintOutOld)(VARIANT* Background, VARIANT* Append, VARIANT* Range, VARIANT* OutputFileName, VARIANT* From, VARIANT* To, VARIANT* Item, VARIANT* Copies, VARIANT* Pages, VARIANT* PageType, VARIANT* PrintToFile, VARIANT* Collate, VARIANT* FileName, VARIANT* ActivePrinterMacGX, VARIANT* ManualDuplexPrint);
			STDMETHOD(LookupNameProperties)(BSTR Name);
			STDMETHOD(SubstituteFont)(BSTR UnavailableFont, BSTR SubstituteFont);
			STDMETHOD(Repeat)(VARIANT* Times, VARIANT_BOOL* prop);
			STDMETHOD(DDEExecute)(long Channel, BSTR Command);
			STDMETHOD(DDEInitiate)(BSTR App, BSTR Topic, long* prop);
			STDMETHOD(DDEPoke)(long Channel, BSTR Item, BSTR Data);
			STDMETHOD(DDERequest)(long Channel, BSTR Item, BSTR* prop);
			STDMETHOD(DDETerminate)(long Channel);
			STDMETHOD(DDETerminateAll)();
			STDMETHOD(BuildKeyCode)(WdKey Arg1, VARIANT* Arg2, VARIANT* Arg3, VARIANT* Arg4, long* prop);
			STDMETHOD(KeyString)(long KeyCode, VARIANT* KeyCode2, BSTR* prop);
			STDMETHOD(OrganizerCopy)(BSTR Source, BSTR Destination, BSTR Name, WdOrganizerObject Object);
			STDMETHOD(OrganizerDelete)(BSTR Source, BSTR Name, WdOrganizerObject Object);
			STDMETHOD(OrganizerRename)(BSTR Source, BSTR Name, BSTR NewName, WdOrganizerObject Object);
			STDMETHOD(AddAddress)(SAFEARRAY** TagID, SAFEARRAY** Value);
			STDMETHOD(GetAddress)(VARIANT* Name, VARIANT* AddressProperties, VARIANT* UseAutoText, VARIANT* DisplaySelectDialog, VARIANT* SelectDialog, VARIANT* CheckNamesDialog, VARIANT* RecentAddressesChoice, VARIANT* UpdateRecentAddresses, BSTR* prop);
			STDMETHOD(CheckGrammar)(BSTR String, VARIANT_BOOL* prop);
			STDMETHOD(CheckSpelling)(BSTR Word, VARIANT* CustomDictionary, VARIANT* IgnoreUppercase, VARIANT* MainDictionary, VARIANT* CustomDictionary2, VARIANT* CustomDictionary3, VARIANT* CustomDictionary4, VARIANT* CustomDictionary5, VARIANT* CustomDictionary6, VARIANT* CustomDictionary7, VARIANT* CustomDictionary8, VARIANT* CustomDictionary9, VARIANT* CustomDictionary10, VARIANT_BOOL* prop);
			STDMETHOD(ResetIgnoreAll)();
			STDMETHOD(GetSpellingSuggestions)(BSTR Word, VARIANT* CustomDictionary, VARIANT* IgnoreUppercase, VARIANT* MainDictionary, VARIANT* SuggestionMode, VARIANT* CustomDictionary2, VARIANT* CustomDictionary3, VARIANT* CustomDictionary4, VARIANT* CustomDictionary5, VARIANT* CustomDictionary6, VARIANT* CustomDictionary7, VARIANT* CustomDictionary8, VARIANT* CustomDictionary9, VARIANT* CustomDictionary10, IDispatch** prop);
			STDMETHOD(GoBack)();
			STDMETHOD(Help)(VARIANT* HelpType);
			STDMETHOD(AutomaticChange)();
			STDMETHOD(ShowMe)();
			STDMETHOD(HelpTool)();
			STDMETHOD(NewWindow)(IDispatch** prop);
			STDMETHOD(ListCommands)(VARIANT_BOOL ListAllCommands);
			STDMETHOD(ShowClipboard)();
			STDMETHOD(OnTime)(VARIANT* When, BSTR Name, VARIANT* Tolerance);
			STDMETHOD(NextLetter)();
			STDMETHOD(MountVolume)(BSTR Zone, BSTR Server, BSTR Volume, VARIANT* User, VARIANT* UserPassword, VARIANT* VolumePassword, short* prop);
			STDMETHOD(CleanString)(BSTR String, BSTR* prop);
			STDMETHOD(SendFax)();
			STDMETHOD(ChangeFileOpenDirectory)(BSTR Path);
			STDMETHOD(RunOld)(BSTR MacroName);
			STDMETHOD(GoForward)();
			STDMETHOD(Move)(long Left, long Top);
			STDMETHOD(Resize)(long Width, long Height);
			STDMETHOD(InchesToPoints)(float Inches, float* prop);
			STDMETHOD(CentimetersToPoints)(float Centimeters, float* prop);
			STDMETHOD(MillimetersToPoints)(float Millimeters, float* prop);
			STDMETHOD(PicasToPoints)(float Picas, float* prop);
			STDMETHOD(LinesToPoints)(float Lines, float* prop);
			STDMETHOD(PointsToInches)(float Points, float* prop);
			STDMETHOD(PointsToCentimeters)(float Points, float* prop);
			STDMETHOD(PointsToMillimeters)(float Points, float* prop);
			STDMETHOD(PointsToPicas)(float Points, float* prop);
			STDMETHOD(PointsToLines)(float Points, float* prop);
			STDMETHOD(Activate)();
			STDMETHOD(PointsToPixels)(float Points, VARIANT* fVertical, float* prop);
			STDMETHOD(PixelsToPoints)(float Pixels, VARIANT* fVertical, float* prop);
			STDMETHOD(KeyboardLatin)();
			STDMETHOD(KeyboardBidi)();
			STDMETHOD(ToggleKeyboard)();
			STDMETHOD(Keyboard)(VARIANT LangId, VARIANT* prop);
			STDMETHOD(ProductCode)(BSTR* prop);
			STDMETHOD(DefaultWebOptions)(IDispatch** prop);
			STDMETHOD(DiscussionSupport)(VARIANT* Range, VARIANT* cid, VARIANT* piCSE);
			STDMETHOD(SetDefaultTheme)(BSTR Name, WdDocumentMedium DocumentType);
			STDMETHOD(GetDefaultTheme)(WdDocumentMedium DocumentType, BSTR* prop);
			STDMETHOD(get_EmailOptions)(IDispatch** prop);
			STDMETHOD(get_Language)(MsoLanguageID* prop);
			STDMETHOD(get_COMAddIns)(IDispatch** prop);
			STDMETHOD(get_CheckLanguage)(VARIANT_BOOL* prop);
			STDMETHOD(put_CheckLanguage)(VARIANT_BOOL prop);
			STDMETHOD(get_LanguageSettings)(IDispatch** prop);
			STDMETHOD(get_Dummy1)(VARIANT_BOOL* prop);
			STDMETHOD(get_AnswerWizard)(IDispatch** prop);
			STDMETHOD(get_FeatureInstall)(MsoFeatureInstall* prop);
			STDMETHOD(put_FeatureInstall)(MsoFeatureInstall prop);
			STDMETHOD(PrintOut2000)(VARIANT* Background, VARIANT* Append, VARIANT* Range, VARIANT* OutputFileName, VARIANT* From, VARIANT* To, VARIANT* Item, VARIANT* Copies, VARIANT* Pages, VARIANT* PageType, VARIANT* PrintToFile, VARIANT* Collate, VARIANT* FileName, VARIANT* ActivePrinterMacGX, VARIANT* ManualDuplexPrint, VARIANT* PrintZoomColumn, VARIANT* PrintZoomRow, VARIANT* PrintZoomPaperWidth, VARIANT* PrintZoomPaperHeight);
			STDMETHOD(Run)(BSTR MacroName, VARIANT* varg1, VARIANT* varg2, VARIANT* varg3, VARIANT* varg4, VARIANT* varg5, VARIANT* varg6, VARIANT* varg7, VARIANT* varg8, VARIANT* varg9, VARIANT* varg10, VARIANT* varg11, VARIANT* varg12, VARIANT* varg13, VARIANT* varg14, VARIANT* varg15, VARIANT* varg16, VARIANT* varg17, VARIANT* varg18, VARIANT* varg19, VARIANT* varg20, VARIANT* varg21, VARIANT* varg22, VARIANT* varg23, VARIANT* varg24, VARIANT* varg25, VARIANT* varg26, VARIANT* varg27, VARIANT* varg28, VARIANT* varg29, VARIANT* varg30, VARIANT* prop);
			STDMETHOD(PrintOut)(VARIANT* Background, VARIANT* Append, VARIANT* Range, VARIANT* OutputFileName, VARIANT* From, VARIANT* To, VARIANT* Item, VARIANT* Copies, VARIANT* Pages, VARIANT* PageType, VARIANT* PrintToFile, VARIANT* Collate, VARIANT* FileName, VARIANT* ActivePrinterMacGX, VARIANT* ManualDuplexPrint, VARIANT* PrintZoomColumn, VARIANT* PrintZoomRow, VARIANT* PrintZoomPaperWidth, VARIANT* PrintZoomPaperHeight);
			STDMETHOD(get_AutomationSecurity)(MsoAutomationSecurity* prop);
			STDMETHOD(put_AutomationSecurity)(MsoAutomationSecurity prop);
			STDMETHOD(get_FileDialog)(MsoFileDialogType FileDialogType, IDispatch** prop);
			STDMETHOD(get_EmailTemplate)(BSTR* prop);
			STDMETHOD(put_EmailTemplate)(BSTR prop);
			STDMETHOD(get_ShowWindowsInTaskbar)(VARIANT_BOOL* prop);
			STDMETHOD(put_ShowWindowsInTaskbar)(VARIANT_BOOL prop);
			STDMETHOD(get_NewDocument)(IDispatch** prop);
			STDMETHOD(get_ShowStartupDialog)(VARIANT_BOOL* prop);
			STDMETHOD(put_ShowStartupDialog)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoCorrectEmail)(IDispatch** prop);
			STDMETHOD(get_TaskPanes)(IDispatch** prop);
			STDMETHOD(get_DefaultLegalBlackline)(VARIANT_BOOL* prop);
			STDMETHOD(put_DefaultLegalBlackline)(VARIANT_BOOL prop);
			STDMETHOD(Dummy2)(VARIANT_BOOL* prop);
			STDMETHOD(get_SmartTagRecognizers)(IDispatch** prop);
			STDMETHOD(get_SmartTagTypes)(IDispatch** prop);
			STDMETHOD(get_XMLNamespaces)(IDispatch** prop);
			STDMETHOD(PutFocusInMailHeader)();
			STDMETHOD(get_ArbitraryXMLSupportAvailable)(VARIANT_BOOL* prop);
			STDMETHOD(get_OperatingSystem)(BSTR* prop);
			STDMETHOD(get_ProcessorType)(BSTR* prop);
			STDMETHOD(get_FreeDiskSpace)(long* prop);
			STDMETHOD(get_Country)(WdCountry* prop);
			STDMETHOD(get_LanguageDesignation)(BSTR* prop);
			STDMETHOD(get_HorizontalResolution)(long* prop);
			STDMETHOD(get_VerticalResolution)(long* prop);
			STDMETHOD(get_ProfileString)(BSTR Section, BSTR Key, BSTR* prop);
			STDMETHOD(put_ProfileString)(BSTR Section, BSTR Key, BSTR prop);
			STDMETHOD(get_PrivateProfileString)(BSTR FileName, BSTR Section, BSTR Key, BSTR* prop);
			STDMETHOD(put_PrivateProfileString)(BSTR FileName, BSTR Section, BSTR Key, BSTR prop);
			STDMETHOD(get_MathCoprocessorInstalled)(VARIANT_BOOL* prop);
			STDMETHOD(get_ComputerType)(BSTR* prop);
			STDMETHOD(get_MacintoshName)(BSTR* prop);
			STDMETHOD(get_QuickDrawInstalled)(VARIANT_BOOL* prop);
			STDMETHOD(get_Cursor)(WdCursorType* prop);
			STDMETHOD(put_Cursor)(WdCursorType prop);
			STDMETHOD(MSInfo)();
			STDMETHOD(Connect)(BSTR Path, VARIANT* Drive, VARIANT* Password);
			STDMETHOD(get_CountryRegion)(WdCountry* prop);
			STDMETHOD(get_VBProjects)(IDispatch** lppptReturn);
			STDMETHOD(get_CodePanes)(IDispatch** ppCodePanes);
			STDMETHOD(get_Events)(IDispatch** ppevtEvents);
			STDMETHOD(get_ActiveVBProject)(IDispatch** lppptReturn);
			STDMETHOD(putref_ActiveVBProject)(IDispatch* lppptReturn);
			STDMETHOD(get_SelectedVBComponent)(IDispatch** lppscReturn);
			STDMETHOD(get_MainWindow)(IDispatch** ppwin);
			STDMETHOD(get_ActiveCodePane)(IDispatch** ppCodePane);
			STDMETHOD(putref_ActiveCodePane)(IDispatch* ppCodePane);
			STDMETHOD(get_Addins)(IDispatch** lpppAddIns);
			STDMETHOD(get_Width)(long* width);
			STDMETHOD(get_MAPIAvailable)(VARIANT_BOOL* prop);
			STDMETHOD(get_DisplayScreenTips)(VARIANT_BOOL* prop);
			STDMETHOD(get_UserControl)(VARIANT_BOOL* prop);
			STDMETHOD(get_FileSearch)(IDispatch** prop);
			STDMETHOD(EnumConnectionPoints)(IEnumConnectionPoints** ppEnum);
			STDMETHOD(FindConnectionPoint)(REFIID riid, IConnectionPoint** ppCP);
		};

		OBJECT_ENTRY_AUTO(__uuidof(Application), CApplication)
	}
}