
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_INLINE_SHAPES_H_
#define _WORD_INLINE_SHAPES_H_

#include "WordInlineShape.h"

namespace AutomateIT
{
    namespace WordClone
    {
        class ATL_NO_VTABLE CWordInlineShapes : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public IDispatchImpl<InlineShapes, &__uuidof(InlineShapes), &LIBID_WordCloneLib, 8, 3>
        {
        public:
            CWordInlineShapes();
            virtual ~CWordInlineShapes();

            BEGIN_COM_MAP(CWordInlineShapes)
                COM_INTERFACE_ENTRY(InlineShapes)
                COM_INTERFACE_ENTRY(IDispatch)
            END_COM_MAP()

            DECLARE_PROTECT_FINAL_CONSTRUCT()

            HRESULT FinalConstruct()
            {
                return S_OK;
            }

            void FinalRelease() 
            {
            }
            
            STDMETHOD(get_Application)(IApplication** RetValue);
            STDMETHOD(get_Creator)(long* prop);
            STDMETHOD(get_Parent)(IDispatch** RetValue);
            STDMETHOD(get_Count)(long* Count);
            STDMETHOD(get__NewEnum)(IUnknown** _NewEnum);
            STDMETHOD(get_Item)(long index, InlineShape** Shape);
            STDMETHOD(get_Range)(VARIANT Index, IDispatch** Range);
            STDMETHOD(AddPicture)(BSTR FileName, VARIANT* LinkToFile, VARIANT* SaveWithDocument, VARIANT* Range, InlineShape** prop);
            STDMETHOD(AddOLEObject)(VARIANT* ClassType, VARIANT* FileName, VARIANT* LinkToFile, VARIANT* DisplayAsIcon, VARIANT* IconFileName, VARIANT* IconIndex, VARIANT* IconLabel, VARIANT* Range, InlineShape** prop);
            STDMETHOD(AddOLEControl)(VARIANT* ClassType, VARIANT* Range, InlineShape** prop);
            STDMETHOD(New)(Range* Range, InlineShape** prop);
            STDMETHOD(AddHorizontalLine)(BSTR FileName, VARIANT* Range, InlineShape** prop);
            STDMETHOD(AddHorizontalLineStandard)(VARIANT* Range, InlineShape** prop);
            STDMETHOD(AddPictureBullet)(BSTR FileName, VARIANT* Range, InlineShape** prop);
        };
    }
}

#endif //_WORD_INLINE_SHAPES_H_