
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_LIST_TEMPLATE_H_
#define _WORD_LIST_TEMPLATE_H_

#include <atlcom.h>
#include "resource.h"       
#include "WordClone.h"
#include "WordListLevels.h"

namespace AutomateIT
{
	namespace WordClone
	{
		class ATL_NO_VTABLE CWordListTemplate :
			public CComObjectRootEx<CComSingleThreadModel>,
			public IDispatchImpl<ListTemplate, &__uuidof(ListTemplate), &LIBID_WordCloneLib, 8, 3>
		{
		public:
			CWordListTemplate();
			virtual ~CWordListTemplate();

			BEGIN_COM_MAP(CWordListTemplate)
				COM_INTERFACE_ENTRY(ListTemplate)
			END_COM_MAP()

			DECLARE_PROTECT_FINAL_CONSTRUCT()

			HRESULT FinalConstruct()
			{
				return S_OK;
			}

			void FinalRelease() 
			{
			}

			// ListTemplate Methods
		public:
			STDMETHOD(get_Application)(IApplication** prop);
			STDMETHOD(get_Creator)(long* prop);
			STDMETHOD(get_Parent)(LPDISPATCH* prop);
			STDMETHOD(get_OutlineNumbered)(VARIANT_BOOL* prop);
			STDMETHOD(put_OutlineNumbered)(VARIANT_BOOL prop);
			STDMETHOD(get_Name)(BSTR* prop);
			STDMETHOD(put_Name)(BSTR prop);
			STDMETHOD(get_ListLevels)(ListLevels** prop);
			STDMETHOD(Convert)(VARIANT* Level, ListTemplate** prop);
		};

		typedef CComObject<CWordListTemplate> WordListTemplateObj;
		typedef CComPtr<CWordListTemplate> WordListTemplatePtr;
	}
}

#endif //_WORD_LIST_TEMPLATE_H_
