
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_SECTIONS_H_
#define _WORD_SECTIONS_H_

#include "WordClone.h"

namespace AutomateIT
{
    namespace WordClone
    {
        class ATL_NO_VTABLE CWordSections : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public IDispatchImpl<Sections, &__uuidof(Sections), &LIBID_WordCloneLib, 8, 3>
        {
        public:

            CWordSections();
            virtual ~CWordSections();

            BEGIN_COM_MAP(CWordSections)
                COM_INTERFACE_ENTRY(Sections)
            END_COM_MAP()

            DECLARE_PROTECT_FINAL_CONSTRUCT()

            HRESULT FinalConstruct()
            {
                return S_OK;
            }

            void FinalRelease() 
            {
            }

            STDMETHOD(get__NewEnum)(IUnknown** prop);
            STDMETHOD(get_Count)(long* prop);
            STDMETHOD(get_First)(IDispatch** prop);
            STDMETHOD(get_Last)(IDispatch** prop);
            STDMETHOD(get_Application)(IApplication** prop);
            STDMETHOD(get_Creator)(long* prop);
            STDMETHOD(get_Parent)(IDispatch** prop);
            STDMETHOD(get_PageSetup)(IDispatch** prop);
            STDMETHOD(put_PageSetup)(IDispatch* prop);
            STDMETHOD(get_Item)(long Index, IDispatch** prop);
            STDMETHOD(Add)(VARIANT* Range, VARIANT* Start, IDispatch** prop);
        };
    }
}

#endif //_WORD_SECTIONS_H_