
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_TABLE_OF_CONTENTS_H_
#define _WORD_TABLE_OF_CONTENTS_H_

#include "WordClone.h"

namespace AutomateIT
{
    namespace WordClone
    {
        class ATL_NO_VTABLE CWordTableOfContents : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public IDispatchImpl<TableOfContents, &__uuidof(TableOfContents), &LIBID_WordCloneLib, 8, 3>
        {
        public:
            CWordTableOfContents();
            virtual ~CWordTableOfContents();

            BEGIN_COM_MAP(CWordTableOfContents)
                COM_INTERFACE_ENTRY(TableOfContents)
                COM_INTERFACE_ENTRY(IDispatch)
            END_COM_MAP()

            DECLARE_PROTECT_FINAL_CONSTRUCT()

            HRESULT FinalConstruct()
            {
                return S_OK;
            }

            void FinalRelease() 
            {
            }

            STDMETHOD(get_Application)(IApplication** prop);
            STDMETHOD(get_Creator)(long* prop);
            STDMETHOD(get_Parent)(IDispatch** prop);
            STDMETHOD(get_UseHeadingStyles)(VARIANT_BOOL* prop);
            STDMETHOD(put_UseHeadingStyles)(VARIANT_BOOL prop);
            STDMETHOD(get_UseFields)(VARIANT_BOOL* prop);
            STDMETHOD(put_UseFields)(VARIANT_BOOL prop);
            STDMETHOD(get_UpperHeadingLevel)(long* prop);
            STDMETHOD(put_UpperHeadingLevel)(long prop);
            STDMETHOD(get_LowerHeadingLevel)(long* prop);
            STDMETHOD(put_LowerHeadingLevel)(long prop);
            STDMETHOD(get_TableID)(BSTR* prop);
            STDMETHOD(put_TableID)(BSTR prop);
            STDMETHOD(get_HeadingStyles)(IDispatch** prop);
            STDMETHOD(get_RightAlignPageNumbers)(VARIANT_BOOL* prop);
            STDMETHOD(put_RightAlignPageNumbers)(VARIANT_BOOL prop);
            STDMETHOD(get_IncludePageNumbers)(VARIANT_BOOL* prop);
            STDMETHOD(put_IncludePageNumbers)(VARIANT_BOOL prop);
            STDMETHOD(get_Range)(Range** prop);
            STDMETHOD(get_TabLeader)(WdTabLeader* prop);
            STDMETHOD(put_TabLeader)(WdTabLeader prop);
            STDMETHOD(Delete)();
            STDMETHOD(UpdatePageNumbers)();
            STDMETHOD(Update)();
            STDMETHOD(get_UseHyperlinks)(VARIANT_BOOL* prop);
            STDMETHOD(put_UseHyperlinks)(VARIANT_BOOL prop);
            STDMETHOD(get_HidePageNumbersInWeb)(VARIANT_BOOL* prop);
            STDMETHOD(put_HidePageNumbersInWeb)(VARIANT_BOOL prop);
        };
    }
}

#endif //_WORD_TABLE_OF_CONTENTS_H_