
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef WORD_VARIABLES_H_
#define WORD_VARIABLES_H_

#include <atlcom.h>
#include "resource.h"
#include "WordClone.h"

namespace AutomateIT
{
	namespace WordClone
	{
		class ATL_NO_VTABLE CWordVariables :
			public CComObjectRootEx<CComSingleThreadModel>,
			public IDispatchImpl<Variables, &__uuidof(Variables), &LIBID_WordCloneLib, 8, 3>
		{
		public:
			CWordVariables();
			virtual ~CWordVariables();

			BEGIN_COM_MAP(CWordVariables)
				COM_INTERFACE_ENTRY(Variables)
			END_COM_MAP()

			DECLARE_PROTECT_FINAL_CONSTRUCT()

			HRESULT FinalConstruct()
			{
				return S_OK;
			}

			void FinalRelease() 
			{
			}

			// Variables interface methods
		public:
			STDMETHOD(get__NewEnum)(LPUNKNOWN* prop);
			STDMETHOD(get_Count)(long* prop);
			STDMETHOD(get_Application)(IApplication** prop);
			STDMETHOD(get_Creator)(long* prop);
			STDMETHOD(get_Parent)(LPDISPATCH* prop);
			STDMETHOD(get_Item)(VARIANT* Index, Variable** prop);
			STDMETHOD(Add)(BSTR Name, VARIANT* Value, Variable** prop);
		};
	}
}

#endif //WORD_VARIABLES_H_